SystemOrganization addCategory: #'GT-ObjectCentricDebugger'!

GTProxyDebugger subclass: #GTObjectCentricProxyDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-ObjectCentricDebugger'!

!GTObjectCentricProxyDebugger classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 11/20/2012 12:10'!
initialize
	super initialize.

	"Add ourselves to registry. See [Smalltalk tools]" 
	Smalltalk tools register: self as: #debugger! !

!GTObjectCentricProxyDebugger methodsFor: 'accessing' stamp: 'AndreiChis 11/19/2012 23:22'!
debuggerClass
	^ GTObjectCentricDebugger! !

GTDebugger subclass: #GTObjectCentricDebugger
	instanceVariableNames: 'watcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-ObjectCentricDebugger'!

!GTObjectCentricDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 11/20/2012 14:26'!
createWatcherThreadForModel: aModel

	watcher isNil ifTrue: [  
		watcher := ([
			Transcript crShow: 'Started'.
			[aModel process isTerminated 
				ifTrue: [
					Transcript crShow: 'terminated'.
					aModel clear.
					browser close.
					Processor activeProcess terminate.
					"also remove the reification"]
				ifFalse: [
					Transcript crShow: 'wait'.
					(Delay forMilliseconds:  100) wait ].
			 false.
			] whileFalse: []. 
		] newProcess priority: Processor userBackgroundPriority).
		watcher resume].
! !

!GTObjectCentricDebugger methodsFor: 'building actions' stamp: 'AndreiChis 11/20/2012 16:09'!
installAtStateChangedFor: aPresentation
	aPresentation
		act: [ :presentation :model |		
			self selectedContext receiver haltAtStateChangeAndNotify: self.
			"self createWatcherThreadForModel: model."
			
			model resume ]
		icon: GLMUIThemeExtraIcons glamorousPlay
		entitled: '-> State'! !

!GTObjectCentricDebugger methodsFor: 'building actions' stamp: 'AndreiChis 11/20/2012 12:13'!
installDebuggingActionsFor: aPresentation
	super installDebuggingActionsFor: aPresentation.
	
	self installNextMessageActionFor: aPresentation.
	self installAtStateChangedFor: aPresentation! !

!GTObjectCentricDebugger methodsFor: 'building actions' stamp: 'AndreiChis 11/21/2012 14:35'!
installNextMessageActionFor: aPresentation
	aPresentation
		act: [ :presentation :model |
			Transcript crShow: 'GTObjectCentricDebugger>>installNextMessageActionFor:'.
			Transcript crShow: '    Processor activeProcess : ', Processor activeProcess name.
			Transcript crShow: '    UIManager default : ',UIManager default uiProcess name.
			Transcript crShow: '    self model process: ', self model process name.
		
			self selectedContext receiver haltAtNextMessageAndNotify: (WeakSet new add: self ; yourself).
			"self createWatcherThreadForModel: model."
			
			model resume. ]
		icon: GLMUIThemeExtraIcons glamorousPlay
		entitled: '-> Message'! !

!GTObjectCentricDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 11/20/2012 16:10'!
resetDebuggerWithContext: newContext fromProcess: aProcess
	"Reset the context and the process associated with this debugger,
	and make sure aProcess is not the UI thread.
	
	This message should be sent in response to an object centric action 
	from within the process that generated the action."
	
	Transcript crShow: 'GTObjectCentricDebugger>>resetDebuggerWithContext: newContext fromProcess: aProcess'.	
	Transcript crShow: '    Processor activeProcess : ', Processor activeProcess name.
	Transcript crShow: '    UIManager default : ',UIManager default uiProcess name.
	Transcript crShow: '    aProcess name: ', aProcess name.
	Transcript crShow: '    self model process: ', self model process name.
	
	"self terminateWatcher."
	
	UIManager default spawnNewProcessIfThisIsUI: aProcess.
	WorldState
		addDeferredUIMessage: [self updateModelWithContext: newContext fromProcess: aProcess].
	aProcess suspend.
	! !

!GTObjectCentricDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 11/20/2012 14:30'!
terminateWatcher
	watcher isNil ifFalse: [
		watcher isTerminated ifFalse:  [watcher terminate].  
		watcher :=nil]! !

!GTObjectCentricDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 11/20/2012 15:39'!
updateModelWithContext: newContext fromProcess: aProcess
	"Update the debugger model and reset the selection"

	Transcript crShow: 'GTObjectCentricDebugger>>updateModelWithContext: newContext fromProcess: aProcess'.	
	Transcript crShow: '    Processor activeProcess : ', Processor activeProcess name.
	Transcript crShow: '    UIManager default : ',UIManager default uiProcess name.
	Transcript crShow: '    aProcess name: ', aProcess name.
	Transcript crShow: '    self model process: ', self model process name.
			
	self model updateWithContext: newContext fromProcess: aProcess.
	self selectTopOfStack: self model context
	! !

Halt subclass: #GTTransparentBreakpoint
	instanceVariableNames: 'receivers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-ObjectCentricDebugger'!

!GTTransparentBreakpoint classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 11/21/2012 11:16'!
signalAndNotify: aWeakCollection

	^ self new signalAndNotify: aWeakCollection ! !

!GTTransparentBreakpoint methodsFor: 'as yet unclassified' stamp: 'AndreiChis 11/21/2012 14:48'!
defaultAction 	
	Transcript crShow: 'GTTransparentBreakpoint>>defaultAction activeProcess: ', Processor activeProcess name.
	
	receivers do: [:each| 
		Transcript crShow: 'GTTransparentBreakpoint>>defaultAction each ', each class name.
		each resetDebuggerWithContext: self signalerContext fromProcess:  Processor activeProcess].! !

!GTTransparentBreakpoint methodsFor: 'as yet unclassified' stamp: 'AndreiChis 11/21/2012 11:17'!
signalAndNotify: aWeakCollection

	receivers := aWeakCollection.
	super signal.! !

!Object methodsFor: '*gt-objectcentricdebugger' stamp: 'AndreiChis 11/19/2012 23:09'!
haltAtNextMessageAndNotify: anObject
	| aMetaObject |
	aMetaObject := BFBehavioralMetaObject new.
	aMetaObject 
		when: (BFMessageReceiveEvent new) 
		do: [:receiver :selector :arguments |  
			self metaObject unbindFrom: self. 
			GTTransparentBreakpoint signalAndNotify: anObject.
			
			"WorldState
				addDeferredUIMessage: [ 
					aNotifier doSomething: thisContext contextTag].
			Processor activeProcess suspend " ].
	aMetaObject bindTo: self ! !

!Object methodsFor: '*gt-objectcentricdebugger' stamp: 'AndreiChis 11/20/2012 15:35'!
haltAtStateChangeAndNotify: anObject
	| aMetaObject |
	aMetaObject := BFBehavioralMetaObject new.
	aMetaObject
		when: (BFVariableWriteEvent new) 
		do: [ 
			self metaObject unbindFrom: self. 
			GTTransparentBreakpoint signalAndNotify: anObject].
	aMetaObject bindTo: self ! !

GTDebuggerSession subclass: #GTObjectCentricDebuggerSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-ObjectCentricDebugger'!
GTObjectCentricProxyDebugger initialize!
